-- In case you aren't reading this in a editor that understands Lua code and colors text accordingly (eg. Notepad++):
-- * Any line starting with '--' is a comment
-- * Items between '--[[' and '--]]' have been disabled
-- * Items between '---[[' and '--]]' are enabled (the opening comment tag is itself commented out)

--WARNING: variables that are to evaluate as false must be set to either nil or false.
--variables set to 0, "0" or "" are evaluated as true.

--Set some values to be accessable throughout the addon code
F2PAddonGlobalVars = {}
F2PAddonGlobalVars.addonVersion = GetAddOnMetadata("F2PAddon", "Version")
F2PAddonGlobalVars.myName = GetUnitName("player",0)
F2PAddonGlobalVars.myFaction = UnitFactionGroup("player")
F2PAddonGlobalVars.thisRealm = GetRealmName()

F2PAddonGlobalVars.inChatList = {}
F2PAddonGlobalVars.onlineFriendsList = {}
F2PAddonGlobalVars.whoList = {}
F2PAddonGlobalVars.queueData = {}

F2PAddonGlobalVars.channelListOK = false
F2PAddonGlobalVars.friendsListOK = false

--#####################################################################
--# User changable flags - Do not modify anything above this Section. #
--# Set these as 'false' to disable, 'true' to enable.                #
--#####################################################################

--Default channels used by the addon.  Both must be changed if you intend to use the addon on a different channel.
---[[
F2PAddonGlobalVars.channelName = "f2ptwink" --The in game chat channel.
F2PAddonGlobalVars.addonChannel = "f2paddonchannel"  --The channel used by the addon to send data to other people's copies of the addon.
--]]

--Channels used by the addon when testing (disabled here)
--[[
F2PAddonGlobalVars.channelName = "f2paddontest"
F2PAddonGlobalVars.addonChannel = "f2ptestchannel"
--]]


--You can set this to give a different channel header name, such as "Guild" if you want to display that instead of the default "[1_ f2ptwink]".  This only affects the messages sent through the addon.  Not those sent by payed accounts to the channel normally.
F2PAddonGlobalVars.channelHeader = false


--When enabled this both hides messages sent to you by levels 1, 2 and 24, and prevents you from sending messages yourself if you are at one of those levels.  There is no point disabling this unless everyone else in the channel does the same.
F2PAddonGlobalVars.security = true


--When enabled this will show test messages that are embedded in the addon code to help with debugging.  While the macros '/run F2PAddonGlobalVars.verbose = true' and '/run F2PAddonGlobalVars.verbose = false' can be used in game to turn the messages on and off, you will need to make the change here to see the messages displayed as the addon starts up.
F2PAddonGlobalVars.verbose = false


--Blizzard return false to their IsTrialAccount() function before they actually take off all the trial resrictions.  Enable this to use the addon in the ~72 hour period between upgrading an account, and the restrictions being fully lifted, then set it back to false.
F2PAddonGlobalVars.stillTreatedAsTrialFix = false