---[[
local channelName = F2PAddonGlobalVars.channelName
local addonChannel = F2PAddonGlobalVars.addonChannel
--]]

local trimList = {}
local friendsCap = 95

--[[
function F2PFriends_FLPurge()  --removes all offline friends who do not have a note
	local f_num = GetNumFriends()
	for y = 1, f_num do
		local name, level, class, loc, connected, status, note = GetFriendInfo(y)
		if (connected == nil) and (note == nil) then
			RemoveFriend(name)
		end
	end
end
--]]

function F2PFriends_FLUpdate()  --updates the game friends list with people from the channel.
	local preUpdateFriendsList = {}
	local addList = {}
	local f_num = GetNumFriends()
	--make a list of who's in friends at the moment
	for y = 1, f_num do
		local name = GetFriendInfo(y);
		tinsert(preUpdateFriendsList, name)
	end

	--create a list of just those people in the channel who aren't yet in the friends list
	for i, v in pairs(F2PAddonGlobalVars.inChatList) do
		if not tContains(preUpdateFriendsList, v) then
			tinsert(addList, F2PAddonGlobalVars.inChatList[i])
		end
	end
	local overflow = GetNumFriends() + #addList - friendsCap
	--ensure there is space in the friends list for the names that are to be added
	if overflow > 0 then
		print("Too many in friends list, removing "..overflow)
		F2PFriends_MakeSpace(overflow)
	end

	--finally add the names to the friends list
	for i = 1, #addList do
		print("Adding "..addList[i].." to friends list")
		AddFriend(addList[i])
		F2PAddonGlobalVars.friendsListOK = false
	end	
end

function F2PFriends_AddJoiner(...)
	local a,b,c,d,e,f,g,h,i = ...
	local friends = {}
	local f_num = GetNumFriends()
	for y = 1, f_num do		--make a list containing current friends
		local name = GetFriendInfo(y)
		tinsert(friends, name)
	end	
	
	--make space for them in the friends list if it's close to capacity
	if not tContains(friends, b) then	--if the person who just joined the channel isn't in it
		if GetNumFriends() > friendsCap then
			F2PFriends_MakeSpace(1)
		end
		print("Adding "..b.." to friends list")
		AddFriend(b)
		F2PAddonGlobalVars.friendsListOK = false
	end
end

function F2PFriends_onlineFriendsList_Update()
	F2PAddonGlobalVars.onlineFriendsList = {}
	local f_num = GetNumFriends()
	for y = 1, f_num do
		local name, level, class, loc, connected, status, note = GetFriendInfo(y);	
		if connected then
			tinsert(F2PAddonGlobalVars.onlineFriendsList, name)
		end
	end	
	F2PAddonGlobalVars.friendsListOK = true	
end
	

--[[
function F2PFriends_RemoveLeaver(...)
	local a,b,c,d,e,f,g,h,i = ...
	local f_num = GetNumFriends()
	for y = 1, f_num do
		local name, level, class, loc, connected, status, note = GetFriendInfo(y);	
		if (name == b) and (note == nil) then
			RemoveFriend(b)
			for i, v in pairs(F2PAddonGlobalVars.onlineFriendsList) do
				if v == b then
					tremove(F2PAddonGlobalVars.onlineFriendsList, i)
				end
			end
		end
	end
end
--]]

function F2PFriends_MakeSpace(toRemove)
	local f_num = GetNumFriends()
	for y = 1, f_num do
		local name, level, class, loc, connected, status, note = GetFriendInfo(y)
		--print(tostring(F2PAddonGlobalVars.thisRealm)..", "..tostring(F2PAddonGlobalVars.myFaction)..", "..tostring(name))
		if F2PAddon_Variables.Realms[F2PAddonGlobalVars.thisRealm][F2PAddonGlobalVars.myFaction][name] then
			if F2PAddon_Variables.Realms[F2PAddonGlobalVars.thisRealm][F2PAddonGlobalVars.myFaction][name]["LLIT"] and (not connected) and (not note) then
				tinsert(trimList,{ ["name"] = name, ["LLIT"] = F2PAddon_Variables.Realms[F2PAddonGlobalVars.thisRealm][F2PAddonGlobalVars.myFaction][name]["LLIT"] })
			end
		end		
	end
	table.sort(trimList, F2PFriends_SortByLLIT)
	for x = 1, toRemove do
		print("Removing "..trimList[x].name.." from friends list")
		RemoveFriend(trimList[x].name)
		
	end
	trimList = {}
end

function F2PFriends_SortByLLIT(a, b)
   
   local examined = {}
   local reference = {}
   --print(a.name..", "..a.LLIT..": "..b.name..", "..b.LLIT)
   examined.y = string.match(a.LLIT, "y(%d%d)")
   examined.M = string.match(a.LLIT, "M(%d%d)")
   examined.d = string.match(a.LLIT, "d(%d%d)")
   examined.h = string.match(a.LLIT, "h(%d%d)")
   examined.m = string.match(a.LLIT, "m(%d%d)")
   
   reference.y = string.match(b.LLIT, "y(%d%d)")
   reference.M = string.match(b.LLIT, "M(%d%d)")
   reference.d = string.match(b.LLIT, "d(%d%d)")
   reference.h = string.match(b.LLIT, "h(%d%d)")
   reference.m = string.match(b.LLIT, "m(%d%d)")
   
   if reference.y > examined.y then
      return true
   elseif reference.y < examined.y then
      return false
   elseif reference.y == examined.y then
      if reference.M > examined.M then
         return true
      elseif reference.M < examined.M then
         return false
      elseif reference.M == examined.M then
         if reference.d > examined.d then
            return true
         elseif reference.d < examined.d then
            return false
         elseif reference.d == examined.d then
            if reference.h > examined.h then
               return true
            elseif reference.h < examined.h then
               return false
            elseif reference.h == examined.h then
               if reference.m > examined.m then
                  return true
               elseif reference.m < examined.m then
                  return false
               elseif reference.m == examined.m then
                  return false
               end
            end
         end
      end
   end
end
