local WSGStatus
local ABStatus
local lastWSGStatus = "none"
local lastABStatus = "none"

function F2PQ_SendUpdate()
	msg = nil
	WSGStatus = "none"
	ABStatus = "none"
	for i = 1, GetMaxBattlefieldID() do
		status, mapName = GetBattlefieldStatus(i)
		if mapName == "Warsong Gulch" then
			WSGStatus = status
		elseif mapName == "Arathi Basin" then
			ABStatus = status
		end
	end

	--as the server spam status events regardless of change, check to only send updates if it's actually changed
	if (WSGStatus ~= "none" and WSGStatus ~= lastWSGStatus) then
		--print("WSG status = "..WSGStatus)
		msg = "W"..WSGStatus
	elseif (WSGStatus == "none" and lastWSGStatus ~= "none") then
		--print("WSG status = rejected entry")
		msg = "Wnone"
	end

	if (ABStatus ~= "none" and ABStatus ~= lastABStatus) then
		--print("AB status = "..ABStatus)
		msg = "A"..ABStatus
	elseif (ABStatus == "none" and lastABStatus ~= "none") then
		--print("AB status = rejected entry")
		msg = "Anone"
	end

	if (WSGStatus == "active") or (ABStatus == "active") then
		F2PAddonQueueInfoFrame:Hide()
	end
	
	if msg then
		local f_num = GetNumFriends()
		for y = 1, f_num do
			local name, level, class, loc, connected, status = GetFriendInfo(y)
			if connected and name then
				ChatThrottleLib:SendAddonMessage("NORMAL", "f2pq", msg, "WHISPER", name)
			end
		end
	end
	--]]
	--print(lastWSGStatus..":"..WSGStatus..", "..lastABStatus..":"..ABStatus)
	lastWSGStatus = WSGStatus
	lastABStatus = ABStatus
	--print(lastWSGStatus..":"..WSGStatus..", "..lastABStatus..":"..ABStatus)
	--print("--------")
end

function F2PQ_ReceiveUpdate(...)
	local sender, msg = ...
	local state
	local map

	--print(msg)
	state = string.match(msg, "^.([%a]+)")

	if state == "none" then
		state = 0
	elseif state == "queued" then
		state = 1
	elseif state == "confirm" then
		state = 2
	elseif state == "active" then
		state = 0
	end
	--print(state)
	
	map = string.match(msg, "^(.)")
	--print(map)

	--print(sender..map..state)
	--update table
	if not F2PAddonGlobalVars.queueData[sender] then
		F2PAddonGlobalVars.queueData[sender] = {}
		F2PAddonGlobalVars.queueData[sender]["class"] = F2PChat_GetSenderClassColorAsHex(sender)
	end
	F2PAddonGlobalVars.queueData[sender][map] = state
		
	--print("F2PAddonGlobalVars.queueData = "..F2PAddonGlobalVars.queueData[sender][map])

	F2PQ_TableToDisplay()
end

function F2PQ_TableToDisplay()
	--parse table and if both maps for a name have no state remove the name
	local toRemove = {}
	for i, v in pairs(F2PAddonGlobalVars.queueData) do
		--print("F2PAddonGlobalVars.queueData[i][\"W\"] = "..tostring(F2PAddonGlobalVars.queueData[i]["W"]))
		--print("F2PAddonGlobalVars.queueData[i][\"A\"] = "..tostring(F2PAddonGlobalVars.queueData[i]["A"]))
		if (F2PAddonGlobalVars.queueData[i]["W"] == 0 or F2PAddonGlobalVars.queueData[i]["W"] == nil) and (F2PAddonGlobalVars.queueData[i]["A"] == 0 or F2PAddonGlobalVars.queueData[i]["A"] == nil) then
			--print(i.." is not active for either BG, removing")
			tinsert(toRemove, i)
		end
	end
	for x = 1, #toRemove do
		F2PAddonGlobalVars.queueData[toRemove[x]] = nil
	end
	
	--parse table and convert contents to text
	local nameList = {}
	local appendText
	local outputText = "\124cFFFFFFFFName         | WSG    | AB\n-------------|--------|--------\n"
	--print("----------------")
	
	--create a sorted list of names from the table
	for i, v in pairs(F2PAddonGlobalVars.queueData) do
		tinsert(nameList, i)
	end
	
	table.sort(nameList)
	
	for x = 1, #nameList do
		if F2PAddonGlobalVars.queueData[nameList[x]]["W"] == 1 then
			wState = "\124cFFFF0000queued"
		elseif F2PAddonGlobalVars.queueData[nameList[x]]["W"] == 2  then
			wState = "\124cFF00FF00popped"
		else
			wState = "      "
		end
		
		if F2PAddonGlobalVars.queueData[nameList[x]]["A"] == 1 then
			aState = "\124cFFFF0000queued"
		elseif F2PAddonGlobalVars.queueData[nameList[x]]["A"] == 2  then
			aState = "\124cFF00FF00popped"
		else
			aState = ""
		end
		
		--fix for regional characters that are considered to have a length of 2 while displayed as 1
		local nameLength = #nameList[x]
		for i, v in string.gmatch(nameList[x], "[^a-zA-Z]") do
			nameLength = nameLength - 0.5
		end
		local name = nameList[x]..string.rep(" ", 12 - nameLength)
--		local name = string.format("%-12s", nameList[x])
		
		appendText = "|cFF"..F2PAddonGlobalVars.queueData[nameList[x]]["class"]..name.."|cFFFFFFFF | "..wState.."\124cFFFFFFFF | "..aState.."\n"
		--print(appendText)
		outputText = outputText..appendText
		--print(outputText)
		--print("----------------")
	end
	
	F2PQText:SetText(outputText)
	
end




